// Automatically generated by the Fast Binary Encoding compiler, do not modify!
// https://github.com/chronoxor/FastBinaryEncoding
// Source: fbe
// Version: 1.2.0.0

package fbe;

import java.io.*;
import java.lang.*;
import java.lang.reflect.*;
import java.math.*;
import java.nio.ByteBuffer;
import java.nio.charset.*;
import java.time.*;
import java.util.*;

import com.google.gson.*;

final class ByteBufferJson implements JsonSerializer<ByteBuffer>, JsonDeserializer<ByteBuffer>
{
    @Override
    public JsonElement serialize(ByteBuffer src, Type typeOfSrc, JsonSerializationContext context)
    {
        return new JsonPrimitive(Base64.getEncoder().encodeToString(src.array()));
    }

    @Override
    public ByteBuffer deserialize(JsonElement json, Type type, JsonDeserializationContext context) throws JsonParseException
    {
        return ByteBuffer.wrap(Base64.getDecoder().decode(json.getAsString()));
    }
}

final class CharacterJson implements JsonSerializer<Character>, JsonDeserializer<Character>
{
    @Override
    public JsonElement serialize(Character src, Type typeOfSrc, JsonSerializationContext context)
    {
        return new JsonPrimitive((long)src);
    }

    @Override
    public Character deserialize(JsonElement json, Type type, JsonDeserializationContext context) throws JsonParseException
    {
        return (char)json.getAsLong();
    }
}

final class InstantJson implements JsonSerializer<Instant>, JsonDeserializer<Instant>
{
    @Override
    public JsonElement serialize(Instant src, Type typeOfSrc, JsonSerializationContext context)
    {
        long nanoseconds = src.getEpochSecond() * 1000000000 + src.getNano();
        return new JsonPrimitive(nanoseconds);
    }

    @Override
    public Instant deserialize(JsonElement json, Type type, JsonDeserializationContext context) throws JsonParseException
    {
        long nanoseconds = json.getAsJsonPrimitive().getAsLong();
        return Instant.ofEpochSecond(nanoseconds / 1000000000, nanoseconds % 1000000000);
    }
}

final class BigDecimalJson implements JsonSerializer<BigDecimal>, JsonDeserializer<BigDecimal>
{
    @Override
    public JsonElement serialize(BigDecimal src, Type typeOfSrc, JsonSerializationContext context)
    {
        return new JsonPrimitive(src.toPlainString());
    }

    @Override
    public BigDecimal deserialize(JsonElement json, Type type, JsonDeserializationContext context) throws JsonParseException
    {
        return new BigDecimal(json.getAsJsonPrimitive().getAsString());
    }
}

final class UUIDJson implements JsonSerializer<UUID>, JsonDeserializer<UUID>
{
    @Override
    public JsonElement serialize(UUID src, Type typeOfSrc, JsonSerializationContext context)
    {
        return new JsonPrimitive(src.toString());
    }

    @Override
    public UUID deserialize(JsonElement json, Type type, JsonDeserializationContext context) throws JsonParseException
    {
        return UUID.fromString(json.getAsJsonPrimitive().getAsString());
    }
}

// Fast Binary Encoding base JSON engine
public final class Json
{
    private static final Gson _engine;

    // Get the JSON engine
    public static Gson getEngine() { return _engine; }

    static
    {
        _engine = register(new GsonBuilder()).create();
    }

    private Json() {}

    public static GsonBuilder register(GsonBuilder builder)
    {
        builder.serializeNulls();
        builder.registerTypeAdapter(ByteBuffer.class, new ByteBufferJson());
        builder.registerTypeAdapter(char.class, new CharacterJson());
        builder.registerTypeAdapter(Character.class, new CharacterJson());
        builder.registerTypeAdapter(Instant.class, new InstantJson());
        builder.registerTypeAdapter(BigDecimal.class, new BigDecimalJson());
        builder.registerTypeAdapter(UUID.class, new UUIDJson());
        return builder;
    }
}
